#pragma once

#include <bits/stdc++.h>
#include "core.h"

const int MAX_G = 4e4+3;
extern std::multiset<Edge> edgeList;

std::multiset<std::pair<int, int>> graph[MAX_G];
bool visited[MAX_G];
bool vazi;

namespace Graph {
	bool workMode = true;

	void debugGraph(){
		for(int i=0;i<Gate::getObjects().size();++i){
			std::cout << i << ": ";
			for(auto x : graph[i]) std::cout << x.first << " ";
			std::cout << '\n';
		}
		for(int i=inOffset;i<Input::getInputs().size()+inOffset;++i){
			std::cout << i << ": ";
			for(auto x : graph[i]) std::cout << x.first << " ";
			std::cout << '\n';
		}
		for(int i=outOffset;i<Output::getOutputs().size()+outOffset;++i){
			std::cout << i << ": ";
			for(auto x : graph[i]) std::cout << x.first << " ";
			std::cout << '\n';
		}
	}

	std::queue<std::pair<int, bool>> q;
	void simulate(){
		for(int i=0;i<Input::getInputs().size();++i){
			q.push(std::make_pair(Input::getInputs()[i]->getId(), Input::getInputs()[i]->state));
			if(vazi) std::cout << Input::getInputs()[i]->getId() << " " << Input::getInputs()[i]->state << std::endl;
		}
		if(vazi) debugGraph();
		//for(auto it=edgeList.begin(); it!=edgeList.end(); it++)
		//	std::cout << (*it).state << " ";
		//std::cout << std::endl;
		memset(visited, 0, sizeof(visited));
		for(int i=0;i<Gate::getObjects().size();++i){
			Gate::getObjects()[i]->in[0] = 0;
			Gate::getObjects()[i]->in[1] = 0;
		}

		while(!q.empty()){
			auto st = q.front();
			q.pop();
			visited[st.first]=true;
			if(st.first>=outOffset) continue;
			for(auto x : graph[st.first]){
				//std::cout << x.first << std::endl;
				for(auto it=edgeList.begin(); it!=edgeList.end(); it++){
					auto edge = *it;
					if(((edge.a==st.first && edge.b==x.first) || (edge.a==x.first && edge.b==st.first))
					  && edge.which==x.second){
					  	if(visited[x.first]==true) continue;
						edge.state = st.second;
						if(vazi) std::cout << st.first << " <-> " << x.first << ", " << edge.state << std::endl;
						if(edge.which==0){
							Gate::getObjects()[x.first]->isA = true;
							Gate::getObjects()[x.first]->in[0] = st.second;
							//if(vazi) std::cout << "usilica 0 " << st.first << " " << x.first << ": " << edge.state << ", ";
							//if(vazi) std::cout << Gate::getObjects()[x.first]->in[0] << Gate::getObjects()[x.first]->in[1] << std::endl;
						}
						if(edge.which==1){
							Gate::getObjects()[x.first]->isB = true;
							Gate::getObjects()[x.first]->in[1] = st.second;
							//if(vazi) std::cout << "usilica 1 " << st.first << " " << x.first << ": " << edge.state << ", ";
							//if(vazi) std::cout << Gate::getObjects()[x.first]->in[0] << Gate::getObjects()[x.first]->in[1] << std::endl;
						}
						if(edge.which==2){
							Output::getOutputs()[x.first-outOffset]->state = st.second;
							//if(vazi) std::cout << "usilica 2 " << st.first << " " << x.first << ": " << edge.state << ", ";
							//if(vazi) std::cout << Gate::getObjects()[x.first]->in[0] << Gate::getObjects()[x.first]->in[1] << std::endl;
						}
						else if(workMode || (Gate::getObjects()[x.first]->isA && Gate::getObjects()[x.first]->isB)){
							q.push(std::make_pair(x.first, Gate::getObjects()[x.first]->evaluate()));
							visited[st.first] = true;
							Gate::getObjects()[x.first]->isA = false;
							Gate::getObjects()[x.first]->isB = false;
						}
						edgeList.erase(it);
						edgeList.insert(edge);
					}
				}

			}
		}
		vazi=0;
	}

}