#pragma once

#include <bits/stdc++.h>
#include <SDL2/SDL.h>
#include "Node.h"
#include "core.h"

unsigned int mm=0;

class Output{
private:
	int x, y;
	int id;
	const int offset=20007;
    const int size=64;
    const int side=16;
	Node in;
    core::ColorRGB ledColor;

	SDL_Rect rect = {x, y, size, size};
	
public:
	bool state;
	static std::vector<Output*> outputs;
	static std::vector<Output*>& getOutputs() {return outputs;}

	Output(int xx, int yy, bool st, core::ColorRGB color)
        : x(xx), y(yy), state(st), ledColor(color){ 
        outputs.push_back(this);
        this->id = mm;
        ++mm;
        in.x=this->x+-8;
        in.y=this->y+this->size/2-8;
    }

	void renderBase(SDL_Renderer* renderer, int r, int g, int b) {
        in.x = this->x - 8;
        in.y = this->y + this->size/2 - 8;
        SDL_Rect inputL = {in.x, in.y, 16, 16};
        SDL_Rect inputF = {in.x+1, in.y+1, 16-2, 16-2};
        SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
        SDL_RenderDrawRect(renderer, &inputL);
        SDL_SetRenderDrawColor(renderer, r, g, b, 255);
        SDL_RenderFillRect(renderer, &inputF);
    }
	void render(SDL_Renderer* renderer, int r, int g, int b){
        
        SDL_Rect fillOut = {this->x, this->y, this->size, this->size};
        if(this->state==false){
            SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
        }
        else{
            SDL_SetRenderDrawColor(renderer, ledColor.r, ledColor.g, ledColor.b, 255);
        }
        SDL_RenderFillRect(renderer, &fillOut);

        renderBase(renderer, r, g, b);
    }

    void postRender(SDL_Renderer* renderer, int r, int g, int b){
        SDL_SetRenderDrawColor(renderer, r, g, b, 255);
        SDL_Rect inputF = {in.x+1, in.y+1, this->side-2, this->side-2};
        SDL_RenderFillRect(renderer, &inputF);
    }
    //void postRender(SDL_Renderer* renderer, int r, int g, int b){
    //    SDL_SetRenderDrawColor(renderer, r, g, b, 255);
    //    SDL_Rect outputF = {out.x+1, out.y+1, this->size-2, this->size-2};
    //    SDL_RenderFillRect(renderer, &outputF);
    //}

    int getId() const {return this->id + offset;}
    core::ColorRGB getLED() const {return this->ledColor;}
    void setLED(core::ColorRGB color) {this->ledColor = color;}
    void setLED(int r, int g, int b) {this->ledColor = core::ColorRGB(r, g, b);}

    int getX() const {return this->x;}
    int getY() const {return this->y;}
    int getSize() const {return this->size;}
    Node& getInputNode() {return in;}

    void setX(const int x) {this->x=x;}
    void setY(const int y) {this->y=y;}
    void setXY(const int x, const int y) {
    	this->x = x;
    	this->y = y;
    }
    void addXY(const int x, const int y) {
    	this->x += x;
    	this->y += y;
    }

    bool isInArea(int mouseX, int mouseY){
        if(mouseX>=x-8 && mouseX<=x && mouseY>=y+size/2-8 && mouseY<=y+size/2+8) return false;
        return mouseX>=x && mouseX<=x+size && mouseY>=y && mouseY<=y+size;
    }
};

