#include <bits/stdc++.h>

#include <SDL2/SDL.h>
#include <glad/glad.h>
#include "core.h"
#include "Gate.h"
#include "Input.h"
#include "Output.h"
#include "Edge.h"
#include "Graph.h"

const int windowWidth = 1600;
const int windowHeight = 900;

core::ColorRGB bgColor(194, 238, 242);
core::ColorRGB nodeColor(74, 141, 247);
core::ColorRGB nodeSelected(44, 209, 118);
core::ColorRGB ledColor(3, 252, 15);

extern std::vector<Gate*> Gate::objects;
extern std::vector<Input*> Input::inputs;
extern std::vector<Output*> Output::outputs;
extern std::multiset<std::pair<int, int>> graph[MAX_G];
extern bool vazi;

int mouseX=0, mouseY=0;
int px=0, py=0;
bool mouseDown = false;
int movingID = -1, movingButtonID = -1, movingOutputID = -1;
int construct, rType, lType;

int leftNode = 0, rightNode = 0, which = -1;

bool ok;


std::multiset<Edge> edgeList;
//std::multiset<Edge> edgeInList;
//std::multiset<Edge> edgeOutList;

int main(int argc, char* argv[]){

    SDL_Window* window=nullptr;
    core::initializeSDL();

    window = SDL_CreateWindow("Logisim v2", (1920-windowWidth)/2, (1080-windowHeight)/3, windowWidth, windowHeight,
            SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL);
    SDL_Renderer* renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);

    SDL_GLContext context;
    context = SDL_GL_CreateContext(window);

    gladLoadGLLoader(SDL_GL_GetProcAddress);
    SDL_Event event;
    bool isRunning = true;
    glViewport(0, 0, windowWidth, windowHeight);

    initializeGates(renderer);
    //initializeIO(renderer);
    SDL_Surface* img1 = SDL_LoadBMP("img/ButtonPressed.bmp");
    SDL_Texture* pressed = SDL_CreateTextureFromSurface(renderer, img1);
    SDL_Surface* img2 = SDL_LoadBMP("img/ButtonReleased.bmp");
    SDL_Texture* released = SDL_CreateTextureFromSurface(renderer, img2);

    ANDGate a(60, 30);
    NANDGate b(400, 30);
    ORGate c(200, 20);
    Input button(600, 600, 0);
    //Input butt(1000, 800, 1);
    //NORGate d(70, 150);
    //XORGate e(190, 140);
    NXORGate f(420, 160);
    //NXORGate e0(600, 400);
    //NXORGate e1(800, 400);
    Output led(700, 700, 0, ledColor);

    std::cout << Gate::getObjects().size() << std::endl;
    for(auto x : Gate::getObjects()){
        std::cout << x->getId() << std::endl;
    }


    while(isRunning){
        px = mouseX; py = mouseY;
        SDL_GetMouseState(&mouseX, &mouseY);       

        while(SDL_PollEvent(&event)){
            if(event.type == SDL_QUIT){
                isRunning = false;
            }
            if(event.type == SDL_MOUSEBUTTONUP) {
                mouseDown = false;
                movingID = -1;
                movingButtonID = -1;
                movingOutputID = -1;

                auto inp = Input::getInputs();
                for(int i=0; i<inp.size(); ++i){
                    //debug("c");
                    if(inp[i]->isInArea(mouseX, mouseY)){
                        vazi=1;
                        inp[i]->state ^= 1;
                        std::cout << inp[i]->state << std::endl;
                        break;
                    }
                    if(inp[i]->getOutputNode().isInArea(mouseX, mouseY)){
                        if(rightNode !=inp[i]->getId()){     
                            std::cout << "BAKINA SENDVICARA" << std::endl;
                            rightNode = inp[i]->getId();
                            rType = EDGE_INPUT;
                        }
                        else{
                            rightNode = 0;
                            rType = EDGE_NONE;
                        }
                    }
                }
                auto objs = Gate::getObjects();
                for(int i=0; i<objs.size(); i+=2){
                    if(objs[i]->getInA().isInArea(mouseX, mouseY)){
                        if(leftNode != objs[i]->getId() || which != 0){
                            std::cout << "GRMILICA" << std::endl;
                            leftNode = objs[i]->getId();
                            which = 0;
                            lType = EDGE_GATE;
                        }
                        else{
                            leftNode = 0;
                            which = -1;
                            lType = EDGE_NONE;
                        }
                    }
                    if(objs[i]->getInB().isInArea(mouseX, mouseY)){
                        if(leftNode != objs[i]->getId() || which != 1){
                            std::cout << "TEBRASTI" << std::endl;
                            leftNode = objs[i]->getId();
                            which = 1;
                            lType = EDGE_GATE;
                        }
                        else{
                            leftNode = 0;
                            which = -1;
                            lType = EDGE_NONE;
                        }
                    }
                    if(objs[i]->getOutputNode().isInArea(mouseX, mouseY)){
                        if(rightNode != objs[i]->getId()){
                            std::cout << "RESILICA" << std::endl;
                            rightNode = objs[i]->getId();
                            rType = EDGE_GATE;
                        }
                        else{
                            rightNode = 0;
                            rType = EDGE_NONE;
                        }
                    }
                }
                auto oup = Output::getOutputs();
                for(int i=0; i<oup.size(); ++i){
                    //debug("c");
                    if(oup[i]->getInputNode().isInArea(mouseX, mouseY)){
                        if(leftNode != oup[i]->getId()){
                            std::cout << "JEDNA PALACINKARINA" << std::endl;
                            leftNode = oup[i]->getId();
                            which = 2;
                            lType = EDGE_OUTPUT;
                        }
                        else{
                            leftNode = 0;
                            which = -1;
                            rType = EDGE_NONE;
                        }
                    }
                }
            }
            if(event.type == SDL_MOUSEBUTTONDOWN){
                mouseDown = true;
                
                auto inp = Input::getInputs();
                for(int i=0; i<inp.size(); ++i){
                    if(core::inRect(mouseX, mouseY, inp[i]->getX(),
                      inp[i]->getY(), inp[i]->getSize(), inp[i]->getSize())){
                        movingButtonID = inp[i]->getId();
                        break;
                    }
                }
                auto objs = Gate::getObjects();
                for(int i=0; i<objs.size(); i+=2){
                    if(core::inRect(mouseX, mouseY, objs[i]->getX(),
                      objs[i]->getY(), objs[i]->getW(), objs[i]->getH())){
                        movingID = objs[i]->getId();
                        break;
                    }
                }
                auto oup = Output::getOutputs();
                for(int i=0; i<oup.size(); ++i){
                    if(core::inRect(mouseX, mouseY, oup[i]->getX(),
                      oup[i]->getY(), oup[i]->getSize(), oup[i]->getSize())){
                        movingOutputID = oup[i]->getId();
                    }
                }
            }
            if(event.type == SDL_KEYDOWN){
                const Uint8* state = SDL_GetKeyboardState(NULL);
                if(state[SDL_SCANCODE_A] && state[SDL_SCANCODE_LSHIFT]){
                    NANDGate* na = new NANDGate(mouseX-64, mouseY-32);
                }
                else if(state[SDL_SCANCODE_A]){
                    ANDGate* a = new ANDGate(mouseX-64, mouseY-32);
                }
                if(state[SDL_SCANCODE_O] && state[SDL_SCANCODE_LSHIFT]){
                    NORGate* no = new NORGate(mouseX-64, mouseY-32);
                }
                else if(state[SDL_SCANCODE_O]){
                    ORGate* o = new ORGate(mouseX-64, mouseY-32);
                }
                if(state[SDL_SCANCODE_X] && state[SDL_SCANCODE_LSHIFT]){
                    NXORGate* nx = new NXORGate(mouseX-64, mouseY-32);
                }
                else if(state[SDL_SCANCODE_X]){
                    XORGate* x = new XORGate(mouseX-64, mouseY-32);
                }
                if(state[SDL_SCANCODE_I] || state[SDL_SCANCODE_B]){
                    Input* i = new Input(mouseX-32, mouseY-32, 0);
                }
                if(state[SDL_SCANCODE_L]){
                    Output* o = new Output(mouseX-32, mouseY-32, 0, ledColor);
                }


                if(state[SDL_SCANCODE_T]){
                    Graph::debugGraph();
                }
                if(state[SDL_SCANCODE_Q]){
                    Graph::workMode ^= 1;
                }
            }
            /*
            if(event.type == SDL_KEYUP){
                if(event.key.keysym.sym == SDLK_a){
                    ANDGate a(mouseX, mouseY);
                }
                if(event.key.keysym.sym == SDLK_x){
                    XORGate x(mouseX, mouseY);
                }
                if(event.key.keysym.sym == SDLK_o){
                    ORGate o(mouseX, mouseY);
                }
            }
            */
        }
        //std::cout << Gate::getObjects().size() << '\n';
        //if(rType == EDGE_INPUT) debug("kiturecka");


        if(leftNode>0 && rightNode>0){

            debug("uso 0");
            bool exist = false;
            for(auto it=edgeList.begin(); it!=edgeList.end(); it++){
                auto edge = *it;
                if(((edge.a==leftNode && edge.b==rightNode) || (edge.a==rightNode && edge.b==leftNode))
                  && edge.which == which){
                    exist = true;
                    edgeList.erase(it);
                    graph[edge.a].erase(graph[edge.a].find(std::make_pair(edge.b, which)));
                    graph[edge.b].erase(graph[edge.b].find(std::make_pair(edge.a, which)));
                    break;
                }
            }
            if(!exist){
                debug("uso 2");
                graph[leftNode].insert({rightNode, which});
                graph[rightNode].insert({leftNode, which});
                    
                if(rType == EDGE_INPUT){
                    auto rGate = Input::getInputs()[rightNode-inOffset];
                    debug("uso 3");
                    if(which==0){
                        auto lGate = Gate::getObjects()[leftNode];
                        Edge edge(leftNode, rightNode, lGate->getX(), lGate->getY()+16,
                          rGate->getX()+64, rGate->getY()+24, 0);
                        edgeList.insert(edge);
                        ok=0;
                    }
                    else if(which==1){
                        auto lGate = Gate::getObjects()[leftNode];
                        Edge edge(leftNode, rightNode, lGate->getX(), lGate->getY()+48,
                          rGate->getX()+64, rGate->getY()+24, 1);
                        edgeList.insert(edge);
                        ok=0;
                    }
                    else if(which==2){
                        auto outLED = Output::getOutputs()[leftNode-outOffset];
                        Edge edge(leftNode, rightNode, outLED->getX(), outLED->getY()+24,
                          rGate->getX()+64, rGate->getY()+24, 2);
                        edgeList.insert(edge);
                        ok=0;
                    }
                }    
                if(rType == EDGE_GATE){
                    auto rGate = Gate::getObjects()[rightNode];
                    if(which==0){
                        auto lGate = Gate::getObjects()[leftNode];
                        Edge edge(leftNode, rightNode, lGate->getX(), lGate->getY()+16,
                          rGate->getX()+128, rGate->getY()+32, 0);
                        edgeList.insert(edge);
                        for(auto x : edgeList){
                            std::cout << x.a << " " << x.b << " " << std::endl;
                        }
                        std::cout << std::endl;
                        ok=0;
                    }
                    else if(which==1){
                        auto lGate = Gate::getObjects()[leftNode];
                        Edge edge(leftNode, rightNode, lGate->getX(), lGate->getY()+48,
                          rGate->getX()+128, rGate->getY()+32, 1);
                        edgeList.insert(edge);
                        for(auto x : edgeList){
                            std::cout << x.a << " " << x.b << " " << std::endl;
                        }
                        std::cout << std::endl;
                        ok=0;

                    }
                    else if(which==2){
                        auto outLED = Output::getOutputs()[leftNode-outOffset];
                        Edge edge(leftNode, rightNode, outLED->getX(), outLED->getY()+24,
                          rGate->getX()+128, rGate->getY()+32, 2);
                        edgeList.insert(edge);
                        ok=0;
                    }
                }
            }
            leftNode = 0;
            rightNode = 0;
            which = -1;
            lType = EDGE_NONE;
            rType = EDGE_NONE;
            vazi = 1;
        }


        if(mouseDown){
            if(movingButtonID>-1){
                auto inpjut = Input::getInputs()[movingButtonID-inOffset];
                inpjut->addXY(mouseX-px, mouseY-py);
            }
            else if(movingID>-1){
                auto movingObj = Gate::getObjects()[movingID];
                movingObj->addXY(mouseX-px, mouseY-py);
                //if(objects[i].second==0)
                //if(objects[i].second==1) 
                //if(objects[i].second==2) 
                //if(objects[i].second==3) 
                //if(objects[i].second==4) 
                //if(objects[i].second==5) a5=
            }
            if(movingOutputID>-1){
                auto outpjut = Output::getOutputs()[movingOutputID-outOffset];
                outpjut->addXY(mouseX-px, mouseY-py);
            }
        }

        SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
        SDL_RenderClear(renderer);

        //BFS OVDE RENDEROVATI
        Graph::simulate();

        for(auto edge : edgeList){
            edge.render(renderer);
        }

        auto in = Input::getInputs();
        for(int i=0; i<in.size(); i++){
            SDL_Rect rect = {in[i]->getX(), in[i]->getY(), in[i]->getSize(), in[i]->getSize()};
            if(in[i]->state==true) SDL_RenderCopy(renderer, pressed, NULL, &rect);
            else SDL_RenderCopy(renderer, released, NULL, &rect);
            in[i]->render(renderer, nodeColor.r, nodeColor.g, nodeColor.b);
        }

        for(int i=0; i<Gate::getObjects().size(); i+=2){
            Gate::getObjects()[i]->render(renderer, nodeColor.r, nodeColor.g, nodeColor.b);
        }
        auto out = Output::getOutputs();
        for(int i=0;i<out.size();++i){
            out[i]->render(renderer, nodeColor.r, nodeColor.g, nodeColor.b);
        }

        if(leftNode>0){
            if(lType==EDGE_OUTPUT){
                Output::getOutputs()[leftNode-outOffset]->postRender(renderer, nodeSelected.r, nodeSelected.g, nodeSelected.b);
            }
            if(lType==EDGE_GATE){
                Gate::getObjects()[leftNode]->postRender(renderer, which, nodeSelected.r, nodeSelected.g, nodeSelected.b);
            }
        }
        if(rightNode>0){
            //std::cout << "--->r " << rightNode << std::endl;
            if(rType==EDGE_INPUT)
                Input::getInputs()[rightNode-inOffset]->postRender(renderer, nodeSelected.r, nodeSelected.g, nodeSelected.b);
            if(rType==EDGE_GATE)
                Gate::getObjects()[rightNode]->postRender(renderer, 2, nodeSelected.r, nodeSelected.g, nodeSelected.b);
        }

        //debug("poco");
        // Update the //screen
        SDL_RenderPresent(renderer);

        glClearColor(bgColor.floatR(), bgColor.floatG(), bgColor.floatB(), 1.0f);
        //glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

        SDL_GL_SwapWindow(window);
    }
    SDL_DestroyWindow(window);
    
    SDL_Delay(800);
    //IMG_Quit();
    SDL_Quit();
    return 0;
}
